
import 'package:flutter/material.dart';

class NativeTextStyle {
  final double fontSize;
  final Color color;
  final Color backgroundColor;
  final bool isVisible;

  const NativeTextStyle({
    this.fontSize,
    this.color,
    this.backgroundColor,
    this.isVisible = true,
  });

  Map<String, dynamic> toJson() => {
        "backgroundColor": backgroundColor != null
            ? "#${backgroundColor.value.toRadixString(16)}"
            : null,
        "fontSize": fontSize,
        "color": color != null ? "#${color.value.toRadixString(16)}" : null,
        "isVisible": isVisible,
      };
}

class NativeAdmobOptions {
  final bool showMediaContent;
  final double sizeMediaContent;
  final Color ratingColor;
  final NativeTextStyle adLabelTextStyle;
  final NativeTextStyle headlineTextStyle;
  final NativeTextStyle advertiserTextStyle;
  final NativeTextStyle bodyTextStyle;
  final NativeTextStyle storeTextStyle;
  final NativeTextStyle priceTextStyle;
  final NativeTextStyle callToActionStyle;

  const NativeAdmobOptions({
    this.showMediaContent = true,
    this.sizeMediaContent = 100,
    this.ratingColor = Colors.yellow,
    this.adLabelTextStyle = const NativeTextStyle(
      fontSize: 10,
      color: Color(0xFF55C3E7),
      backgroundColor: Color(0xFFFFFFFF),
    ),
    this.headlineTextStyle = const NativeTextStyle(
      fontSize: 13,
      color: Colors.black,
    ),
    this.advertiserTextStyle = const NativeTextStyle(
      fontSize: 10,
      color: Colors.black,
    ),
    this.bodyTextStyle = const NativeTextStyle(
      fontSize: 12,
      color: Colors.black,
    ),
    this.storeTextStyle = const NativeTextStyle(
      fontSize: 10,
      color: Colors.black,
    ),
    this.priceTextStyle = const NativeTextStyle(
      fontSize: 10,
      color: Colors.black,
    ),
    this.callToActionStyle = const NativeTextStyle(
      fontSize: 11,
      color: Colors.white,
      backgroundColor: Color(0xFF5A7BEF),
    ),
  });

  Map<String, dynamic> toJson() => {
        "showMediaContent": this.showMediaContent,
        "sizeMediaContent": this.sizeMediaContent,
        "ratingColor": "#${ratingColor.value.toRadixString(16)}",
        "adLabelTextStyle": adLabelTextStyle.toJson(),
        "headlineTextStyle": headlineTextStyle.toJson(),
        "advertiserTextStyle": advertiserTextStyle.toJson(),
        "bodyTextStyle": bodyTextStyle.toJson(),
        "storeTextStyle": storeTextStyle.toJson(),
        "priceTextStyle": priceTextStyle.toJson(),
        "callToActionStyle": callToActionStyle.toJson(),
      };
}
